###################################################################################################################################################
# Copyright 2015 Orchid Systems 
# -----------------------------
# Amended 2017-10-24: Validation triggers upon entry of the DOCDATE field and not upon change to the Posting Date (DATEENTRY) field.
# -----------------------------
# Permitted for use with Orchid Systems Modules only.
# The code is supplied on an as is basis for training and demonstration purposes only and is not supported by Orchid Systems.
# If this code is deployed in a live production environment it is the responsibility of the End User to ensure 
# that it is operating as required.
###################################################################################################################################################


#################### Import Modules ###########################################
from accpac import *

import time
import datetime
import subprocess
from datetime import date

###############################################################################

# Number of days of margin.
warningMargin = 3

def onOpen():
	if rotoID != "GL0006":
		return 0 # don't do anything since the view is not GL0006 G/L Journal Header.

	return Continue


def onAfterPut(e):

	f = str(e.field)
	f = f.strip()

	#if (f == "DATEENTRY"):
	if (f == "DOCDATE"):
		validateJournalEntryDate(e)
	return Continue



def validateJournalEntryDate(e):

	dt = str(e.value)

	global warningMargin

	entryDate = datetime.datetime.strptime(dt, "%Y%m%d").date()
	
	sessionDate = date.today()

	# calculate the date difference:
	daysdiff = abs((entryDate - sessionDate).days)
	
	if (daysdiff > warningMargin):
		exceed = daysdiff - warningMargin
		showMessage("Difference of [" + str(daysdiff) + "] day(s) between entered date and system date exceeds the warning margin of [" + str(warningMargin) + "] day(s) by [" + str(exceed) + "] day(s).")

